SystemOrganization addCategory: #'Famix-Implementation'!
SystemOrganization addCategory: #'Famix-Implementation-Tests'!

TestCase subclass: #FAMIXNameResolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Famix-Implementation-Tests'!

!FAMIXNameResolverTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/20/2011 09:21'!
testFindClassNamed

	self assert: (FAMIXNameResolver findClassNamedOrNilFromFullName: #Object) == Object.
	self assert: (FAMIXNameResolver findClassNamedOrNilFromFullName: #ObjectAbsent) isNil.! !

!FAMIXNameResolverTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/20/2011 09:19'!
testResolvingName
	self assert: (FAMIXNameResolver smalltalkClassFromFamixClassName: #Object ifAbsent: []) == Object.
	self assert: (FAMIXNameResolver smalltalkClassFromFamixClassName: #FooBarZorkAbsent ifAbsent: [10]) == 10.
	
! !

!FAMIXNameResolverTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/20/2011 09:19'!
testSmalltalkNameFromFAMIXNAme
	self assert: (FAMIXNameResolver smalltalkClassNameFromFamixClassName: #Object) == #Object.
	self assert: (FAMIXNameResolver smalltalkClassNameFromFamixClassName: #FooBarZorkAbsent) == #FooBarZorkAbsent.
	
	self assert: (FAMIXNameResolver smalltalkClassNameFromFamixClassName: #M::FooBarZorkAbsent) == #FooBarZorkAbsent! !

!FAMIXClass methodsFor: '*famix-implementation-testing' stamp: 'tg 7/30/2009 20:39'!
isClass
	^ true! !

!FAMIXClass methodsFor: '*Famix-Implementation' stamp: 'usmanbhatti 11/17/2011 16:01'!
smalltalkClass 
	"Returns the associated smalltalk class if it exist in the system."
	
	^ FAMIXNameResolver smalltalkClassFromFamixClassName: 
			self name  ifAbsent: [nil] ! !

!FAMIXStructuralEntity methodsFor: '*Famix-Implementation' stamp: 'simon.denier 1/20/2009 19:00'!
globalAccesses
	| attrclass globalAccesses |
	attrclass := self belongsTo.
	globalAccesses := Set new.
	self
		incomingAccesses do:
			[:anAccess | 
			| ent |
			ent := anAccess accessor.
			ent belongsTo = attrclass ifFalse: [globalAccesses add: anAccess]].
	^globalAccesses! !

!FAMIXStructuralEntity methodsFor: '*Famix-Implementation' stamp: 'tg 5/14/2009 17:36'!
isAttribute
	^ false! !

!FAMIXStructuralEntity methodsFor: '*Famix-Implementation' stamp: 'simon.denier 1/20/2009 18:01'!
localAccesses
	| attrclass localAccesses |
	attrclass := self belongsTo.
	localAccesses := Set new.
	self
		incomingAccesses do:
			[:anAccess | 
			| ent |
			ent := anAccess accessor.
			ent belongsTo = attrclass ifTrue: [localAccesses add: anAccess]].
	^localAccesses! !

!FAMIXPackage methodsFor: '*Famix-Implementation' stamp: 'simon_denier 9/24/2009 16:45'!
abstractClasses

	^ self classes select: [:c | c isAbstract]! !

!FAMIXPackage methodsFor: '*Famix-Implementation' stamp: 'simon.denier 6/7/2010 16:15'!
classes

	^ self privateState 	cacheAt: #classes 
							ifAbsentPut: [ childNamedEntities select: [ :child | child isClass ]]! !

!FAMIXPackage methodsFor: '*Famix-Implementation' stamp: 'janniklaval 5/2/2011 16:01'!
methods

	"^ self privateState 
			cacheAt: #methods 
			ifAbsentPut: [ 
				childNamedEntities select: [ :child | child isKindOf: FAMIXBehaviouralEntity ]]"
	^ self localMethods union: self extensionMethods! !

!FAMIXPackage methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:26'!
printOn: aStream 
	| parent |
	parent := self parentPackage.
	parent ifNotNil: 
		[ parent printOn: aStream.
		aStream
			nextPut: $. ].
	self name ifNotNil: [ aStream nextPutAll: self name ].
	aStream nextPutAll: ' (Package)'! !

!FAMIXContainerEntity methodsFor: '*Famix-Implementation' stamp: 'simon.denier 9/7/2009 16:58'!
addClass: aClass
	
	types add: aClass! !

!FAMIXContainerEntity methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 3/27/2011 10:06'!
classes
	"Classes are usually seen as types from the point of view of a Container. However, there may other types (e.g. aspects) which we dont want to see as classes and are rejected by this method."
	<navigation: 'Classes'>

	^ self privateState 
				cacheAt: #classes 
				ifAbsentPut: [self types select: [:type| type isClass ]]! !

!FAMIXEntity methodsFor: '*Famix-Implementation' stamp: 'tg 7/25/2010 09:09'!
isMethod
	^ false! !

!FAMIXGlobalVariable methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:29'!
printOn: aStream 
	| parent |
	parent := self belongsTo.
	parent ifNotNil:
		[ aStream nextPutAll: parent name.
		aStream nextPut: $. ].
	self name ifNotNil: [ aStream nextPutAll: self name ].
	aStream nextPutAll: ' (Global Variable)'! !

!FAMIXTypeAlias methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:36'!
allSubclassesDo: aBlock
	"we override this traversal because we want to
	traverse the real type as well"
	self realType ifNotNilDo: [:a | a allSubclassesDo: aBlock].
! !

!FAMIXTypeAlias methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
allSuperclassesDo: aBlock
	"we override this traversal because we want to
	traverse the aliased type as well"
	self realType ifNotNilDo: [:a | a allSuperclassesDo: aBlock]! !

!FAMIXTypeAlias methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 9/9/2011 20:29'!
realType
	"The alias type is just an alias.
	The real type is the one provided by the aliasedType "
	^ self aliasedType isNil 
		ifTrue: [nil]
		ifFalse: [self aliasedType realType]! !

!FAMIXSourcedEntity methodsFor: '*Famix-Implementation' stamp: 'stephane.ducasse 11/19/2008 16:29'!
isClass
	
	^ false! !

!FAMIXSourcedEntity methodsFor: '*Famix-Implementation' stamp: 'stephane.ducasse 11/19/2008 16:09'!
isImplicitVariable
	^false! !

!FAMIXInheritance methodsFor: '*Famix-Implementation' stamp: 'tg 5/25/2009 19:38'!
mooseNameOn: aStream

	self subclass name isNil ifFalse: [ aStream nextPutAll: self subclass name].
	aStream nextPutAll: ' -> '.		
	self superclass name isNil ifFalse: [ aStream nextPutAll: self superclass name].! !

!FAMIXInheritance methodsFor: '*Famix-Implementation' stamp: 'simondenier 11/6/2009 17:00'!
printOn: aStream

	self subclass name isNil 
		ifFalse: [ aStream nextPutAll: self subclass name].
	aStream nextPutAll: ' -> '.		
	self superclass name isNil 
		ifFalse: [ aStream nextPutAll: self superclass name].
	aStream nextPutAll: ' (Inheritance)'.
! !

!FAMIXImplicitVariable methodsFor: '*Famix-Implementation' stamp: 'stephane.ducasse 11/19/2008 16:08'!
isImplicitVariable
	^true! !

!FAMIXImplicitVariable methodsFor: '*Famix-Implementation' stamp: 'jannik.laval 7/30/2009 14:32'!
isSelf
	^ self name = #self! !

!FAMIXImplicitVariable methodsFor: '*Famix-Implementation' stamp: 'tg 5/17/2009 16:53'!
isSuper
	^ self name == #super! !

!FAMIXImplicitVariable methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 3/26/2011 00:05'!
mooseNameOn: stream 
	| parent |
	parent := self parentBehaviouralEntity.
	parent ifNotNil: 
		[ parent mooseNameOn: stream.
		stream nextPut: $. ].

	self name ifNotNil: [ stream nextPutAll: self name ]! !

!FAMIXImplicitVariable methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 3/25/2011 23:55'!
printOn: aStream 
	| parent |
	parent := self parentBehaviouralEntity.
	parent ifNotNil: 
		[ aStream nextPutAll: parent name.
		  aStream nextPut: $. ].
	self name ifNotNil: [ aStream nextPutAll: self name ].
	aStream nextPutAll: ' (ImplicitVariable)'! !

!FAMIXNamespace methodsFor: '*Famix-Implementation' stamp: 'simon.denier 6/7/2010 16:17'!
methods
	^ self privateState 
			cacheAt: #methods 
			ifAbsentPut: [ 
				self classes flatCollect: #methods ]! !

!FAMIXNamespace methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:42'!
mooseNameOn: aStream 
	| parent |
	parent := self belongsTo.
	parent ifNotNil: 
		[ parent mooseNameOn: aStream.
		aStream
			nextPut: $:;
			nextPut: $: ].
	self name ifNotNil: [aStream nextPutAll: self name]! !

!FAMIXNamespace methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:26'!
printOn: aStream 
	self belongsTo ifNotNil: [:parent |
		parent printOn: aStream.
		aStream
			nextPut: $:;
			nextPut: $: ].
	self name ifNotNil: [ aStream nextPutAll: self name ].
	aStream nextPutAll: ' (Namespace)'! !

!FAMIXReference methodsFor: '*Famix-Implementation' stamp: 'simon.denier 5/12/2009 12:30'!
mooseNameOn: aStream 
	"aStream nextPutAll: 'Reference'."
	self from name isNil ifFalse: [ aStream nextPutAll: self from name ].
	aStream nextPutAll: ' refers to '.
	self to name isNil ifFalse: [ aStream nextPutAll: self to name ]! !

!FAMIXReference methodsFor: '*Famix-Implementation' stamp: 'simondenier 11/6/2009 17:09'!
printOn: aStream

	self from isNil	
		ifFalse: [aStream nextPutAll: self from name].
	aStream nextPutAll: ' -> '.
	self to isNil	
		ifFalse: [aStream nextPutAll: self to name].
	aStream nextPutAll: ' (Reference)'
! !

!FAMIXScopingEntity methodsFor: '*Famix-Implementation' stamp: 'SantiagoVidal 7/19/2012 14:50'!
printName: aStream 
	self belongsTo ifNotNil: [:parent |
		parent printName: aStream.
		aStream
			nextPut: $:;
			nextPut: $: ].
	self name ifNotNil: [ aStream nextPutAll: self name ].
	"aStream nextPutAll: ' (Namespace)'"! !

!FAMIXAccess methodsFor: '*Famix-Implementation' stamp: 'simondenier 11/6/2009 16:59'!
printOn: aStream

	self accessor name isNil 
		ifFalse: [ aStream nextPutAll: self accessor name].
	aStream nextPutAll: ' -> '.		
	self variable name isNil 
		ifFalse: [ aStream nextPutAll: self variable name].
	aStream nextPutAll: ' (Access)'
	
	! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'usmanbhatti 11/17/2011 17:04'!
compiledMethod
	"Return the compiled method associated to the receiver or nil"
	
	^ self smalltalkClass  compiledMethodAt: self name asSymbol
	
	! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 10/19/2011 21:38'!
isConstant
	<MSEProperty: #isConstant type: #Boolean>
	<derived>
	<MSEComment: 'True if the method simply returns a constant'>
	^#constant = self kind! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 10/19/2011 21:38'!
isConstructor
	<MSEProperty: #isConstructor type: #Boolean>
	<derived>
	<MSEComment: 'True if the method is a constructor of the class'>

	^ #constructor = self kind or: [ 
		self privateState propertyAt: #isConstructor ifAbsent: [false] ]! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'tg 7/25/2010 11:31'!
isConstructor: aBoolean
	self kind: #constructor! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 10/19/2011 21:38'!
isGetter
	<MSEProperty: #isGetter type: #Boolean>
	<derived>
	<MSEComment: 'True if the method is a getter of an attribute'>
	
	^#getter = self kind! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'simon.denier 1/28/2009 14:47'!
isMethod

	^ true! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'tg 7/25/2010 11:42'!
isPureAccessor
	^self isGetter
		or: [self isSetter
		or: [self privateState propertyAt: #isPureAccessor ifAbsent: [false]]]! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 10/19/2011 21:46'!
isSetter
	<MSEProperty: #isSetter type: #Boolean>
	<derived>
	<MSEComment: 'True if the method is a setter on an attribute'>

	^#setter = self kind! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:41'!
mooseNameOn: stream 
	| parent |
	parent := self belongsTo.
	parent ifNotNil: 
		[ parent mooseNameOn: stream.
		stream nextPut: $. ].
	self name ifNotNil: [ stream nextPutAll: self name].
	self signatureFromSmalltalkSelector: stream! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'simon.denier 9/10/2009 17:59'!
parentScope
	"Polymorphic alias to mimic GlobalVariable#parentScope and similar"

	^ self parentType parentScope! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'simondenier 11/6/2009 16:49'!
printOn: aStream 
	parentType name isNil ifFalse: [ aStream nextPutAll: parentType name ].
	aStream nextPutAll: '>>'.
	signature isNil ifFalse: [ aStream nextPutAll: signature ].
	aStream nextPutAll: ' (Method)'.! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:42'!
signatureFromSmalltalkSelector: aStream

	| sym numArgs |
	sym := self name.
	sym ifNil: [ ^ self ].
	
	numArgs := sym numArgs.
	aStream nextPut: $(.
	1
		to: numArgs
		do: [:inx | aStream nextPutAll: 'Object,'].
	numArgs > 0 ifTrue: [aStream skip: -1	"remove last space"].
	aStream nextPut: $).
	! !

!FAMIXMethod methodsFor: '*Famix-Implementation' stamp: 'usmanbhatti 11/17/2011 17:03'!
smalltalkClass 
	"Return the smalltalk class associated with the receiver. Note that it may be different than doing self parentType because the class and metaclass can be merged."
	
	^   ('*_class' match: self parentType name)
			ifTrue: [self parentType smalltalkClass]
			ifFalse: [self hasClassScope 
							ifTrue: [self parentType smalltalkClass class]
							ifFalse: [self parentType smalltalkClass]]! !

!FAMIXComment methodsFor: '*Famix-Implementation' stamp: 'simon.denier 4/21/2009 20:14'!
belongsTo
	
	^ self container! !

!FAMIXComment methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 16:09'!
printOn: aStream

	self content ifNotNil: 
		[ aStream nextPutAll: (self content contractTo: 50) ].
	aStream nextPutAll: ' (comment on '.
	self container printOn: aStream.
	aStream nextPut: $)! !

!FAMIXNamedEntity methodsFor: '*Famix-Implementation' stamp: 'stephane.ducasse 10/20/2008 22:33'!
addModifier: aString
	modifiers add: aString! !

!FAMIXNamedEntity methodsFor: '*Famix-Implementation' stamp: 'stephane.ducasse 10/20/2008 22:33'!
addReceivingInvocation: anInvocation
	receivingInvocations add: anInvocation! !

!FAMIXNamedEntity methodsFor: '*Famix-Implementation' stamp: 'simon.denier 11/16/2008 23:12'!
modifierSet: aBoolean for: aSymbol
	^ aBoolean ifTrue: [self addModifier: aSymbol] ifFalse: [self removeModifier: aSymbol]! !

!FAMIXNamedEntity methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:38'!
mooseNameOn: stream 
	self name ifNotNil: 
		[stream nextPutAll: self name]! !

!FAMIXNamedEntity methodsFor: '*Famix-Implementation' stamp: 'simon.denier 11/7/2008 15:46'!
removeModifier: aString
	modifiers remove: aString ifAbsent: []! !

!FAMIXNamedEntity methodsFor: '*Famix-Implementation' stamp: 'cyrille.delaunay 1/22/2010 15:11'!
stub: aBoolean
	
	self isStub: aBoolean! !

!CompiledMethod methodsFor: '*famix-implementation' stamp: 'simon.denier 4/21/2009 20:24'!
mooseName
	^ self mooseNameWithScope: false! !

!CompiledMethod methodsFor: '*famix-implementation' stamp: 'simon.denier 4/21/2009 20:24'!
mooseNameWithScope: aboolean

	| string |
	string := String streamContents: [:str | 
		str nextPutAll: self methodClass mooseName.
		str nextPut: $..
		str nextPutAll: self selector. 
		self signatureFromSmalltalkSelector: str].
	^ string asSymbol! !

!CompiledMethod methodsFor: '*famix-implementation' stamp: 'Alexandre.Bergel 4/16/2009 20:44'!
signature

	| ws |
	ws := WriteStream on: (String new: 150).
	ws nextPutAll: self selector.
	self signatureFromSmalltalkSelector: ws.
	^ws contents asSymbol! !

!CompiledMethod methodsFor: '*famix-implementation' stamp: 'Alexandre.Bergel 4/16/2009 20:45'!
signatureFromSmalltalkSelector: aStream

	| sym numArgs |
	sym := self selector.
	numArgs := sym numArgs.
	aStream nextPut: $(.
	1
		to: numArgs
		do: [:inx | aStream nextPutAll: 'Object,'].
	numArgs > 0 ifTrue: [aStream skip: -1	"remove last space"].
	aStream nextPut: $).
	! !

!FAMIXParameter methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:46'!
mooseNameOn: stream 
	| parent |
	parent := self parentBehaviouralEntity.
	parent ifNotNil: 
		[ parent mooseNameOn: stream.
		stream nextPut: $. ].
	self name ifNotNil: [stream nextPutAll: self name]! !

!FAMIXParameter methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:31'!
printOn: stream 
	| parent |
	self name ifNotNil: [ stream nextPutAll: self name ].
	stream nextPutAll: ' (parameter'.
	parent := self parentBehaviouralEntity.
	parent ifNotNil: [
		stream nextPutAll: ' in '.
		parent printOn: stream ].
	stream nextPut: $)
! !

!FAMIXInvocation methodsFor: '*Famix-Implementation' stamp: 'simondenier 2/3/2011 22:55'!
mooseDisplayStringOn: aStream
	self from isNil ifFalse: [self from mooseDisplayStringOn: aStream].
	aStream nextPutAll: ' -> '.
	self receiver isNil	ifFalse: [aStream nextPutAll: self receiver name].
	aStream nextPut: $#.
	aStream nextPutAll: self signature! !

!FAMIXInvocation methodsFor: '*Famix-Implementation' stamp: 'simondenier 2/3/2011 22:56'!
printOn: aStream

	self from isNil	
		ifFalse: [aStream nextPutAll: self from name].
	aStream nextPutAll: ' -> '.
	self receiver isNil	
		ifFalse: [aStream nextPutAll: self receiver name].
	aStream nextPut: $#.
	aStream nextPutAll: self signature.
	aStream nextPutAll: ' (Invocation)'! !

!FAMIXLocalVariable methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:46'!
mooseNameOn: stream 
	| parent |
	parent := self parentBehaviouralEntity.
	parent ifNotNil: 
		[ parent mooseNameOn: stream.
		stream nextPut: $. ].
	self name ifNotNil: [stream nextPutAll: self name]! !

!FAMIXLocalVariable methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:30'!
printOn: stream 
	| parent |
	self name ifNotNil: [ stream nextPutAll: self name ].
	stream nextPutAll: ' (local variable'.
	parent := self parentBehaviouralEntity.
	parent ifNotNil: [
		stream nextPutAll: ' in '.
		parent printOn: stream ].
	stream nextPut: $)
! !

!FAMIXAttribute methodsFor: '*Famix-Implementation' stamp: 'simon.denier 5/28/2009 11:50'!
accessingClasses

	^(self accessingMethods collectAsSet: [:each | each belongsTo]) asOrderedCollection! !

!FAMIXAttribute methodsFor: '*Famix-Implementation' stamp: 'simon.denier 5/28/2009 11:51'!
accessingMethods

	^ self incomingAccesses collectAsSet: [:anAccess | anAccess accessor].
! !

!FAMIXAttribute methodsFor: '*Famix-Implementation' stamp: 'tg 5/14/2009 17:36'!
isAttribute
	^ true! !

!FAMIXAttribute methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:28'!
mooseNameOn: aStream 
	| parent |
	parent := self belongsTo.
	parent ifNotNil: 
		[ parent mooseNameOn: aStream.
		aStream nextPut: $. ].
	self name ifNotNil: [ aStream nextPutAll: self name ].! !

!FAMIXAttribute methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:28'!
printOn: aStream 
	| parent |
	parent := self belongsTo.
	parent ifNotNil:
		[ aStream nextPutAll: parent name.
		aStream nextPut: $. ].
	self name ifNotNil: [ aStream nextPutAll: self name ].
	aStream nextPutAll: ' (Attribute)'! !

!FAMIXAttribute methodsFor: '*Famix-Implementation' stamp: 'simon.denier 3/31/2009 13:54'!
readAccesses
	
	^self incomingAccesses select: [:each | each isRead]! !

!FAMIXAnnotationType methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:40'!
mooseNameOn: aStream 
	| parent |
	parent := self container.
	parent ifNotNil: 
		[ 
			parent mooseNameOn: aStream.
			aStream
				nextPut: $:;
				nextPut: $: ].
	self name ifNotNil: [aStream nextPutAll: self name]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
addedMethods
	| inheritedMethodNames |
	inheritedMethodNames := self inheritedMethods
		collect: [:each | each signature].
	^self methods
		reject: [:each | inheritedMethodNames includes: each signature]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:49'!
allSubclassesDo: aBlock
	self allSubclassesWithoutAliasesDo: aBlock.
	self typeAliases do: [ :each | each allSubclassesWithoutAliasesDo: aBlock ]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:37'!
allSubclassesWithoutAliasesDo: aBlock
	self subInheritances do: [ :each | aBlock value: each subclass ].
	self subInheritances do: [ :each | each subclass allSubclassesDo: aBlock ]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
allSuperclassesDo: aBlock
	self allSuperclassesWithoutAliasesDo: aBlock.
	self typeAliases do: [ :each | each allSuperclassesWithoutAliasesDo: aBlock ]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
allSuperclassesWithoutAliasesDo: aBlock
	superInheritances do: [:each | aBlock value: each superclass].
	superInheritances do: [:each | each superclass allSuperclassesDo: aBlock]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 9/9/2011 18:40'!
allTypeAliases
	| all |
	all := OrderedCollection withAll: self typeAliases.
	self typeAliases do: [:each | all addAll: each allTypeAliases ].
	^ all! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
anySuperclass
	self allSuperclassesDo: [ :each | ^each ].
	^ nil! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
directSubclasses
	"returns a collection with all subclasses of this class"

	^ self subInheritances collect: [:each | each subclass]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
directSuperclasses
	"returns a collection with all superclasses of this class"

	^ self superInheritances collect: [:each | each superclass]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
implementationOf: signature
	self withSuperclassesDo: [ :class | | found |
			found := class methods
				detect: [ :method | method signature = signature ]
				ifNone: [ nil ].
			found ifNotNil: [ ^found ] ].
	^ nil! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
implements: aString
	^ self methods anySatisfy: [:each | aString match: each signature ]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
inheritedAttributes
	| inheritedAttrs |
	inheritedAttrs := OrderedCollection new.
	self allSuperclassesDo: [:each | 
			each attributes do: [:attr | 
				attr isPrivate not ifTrue: [inheritedAttrs add: attr]]].
	^ inheritedAttrs! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
inheritedMethods
	| inheritedMethods |
	inheritedMethods := OrderedCollection new.
	self allSuperclassesDo: [:each | 
			each methodsDo: [:method | 
				method isPrivate not ifTrue: [inheritedMethods add: method]]].
	^inheritedMethods! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
inheritedSignatures
	| inheritedSignatures |
	inheritedSignatures := Set new.
	self superclassHierarchy do: [:each | 
			each methodsDo: [:method | 
				method isPrivate not ifTrue: [inheritedSignatures add: method signature]]].
	^ inheritedSignatures! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
inheritedSignaturesToMethod
	| inheritedSignaturesToMethod |
	inheritedSignaturesToMethod := Dictionary new.
	self allSuperclassesDo: [:each | 
			each methodsDo: [:method | 
				method isPrivate ifFalse: [
					inheritedSignaturesToMethod at: method signature ifAbsentPut: [method]]]].
	^ inheritedSignaturesToMethod! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
inheritsFrom: aClass
	self allSuperclassesDo: [:each | each = aClass ifTrue: [^true]].
	^ false! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
methodsDo: aBlock
	self methods do: aBlock! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
methodsGroup
	<navigation: 'Methods'>
	^MooseGroup
		withAll: self methods
		withDescription: 'Methods from ' , self mooseName! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'VanessaPena 3/16/2011 17:40'!
mooseNameOn: aStream 
	| parent |
	parent := self container.
	parent ifNotNil: 
		[ 
			parent mooseNameOn: aStream.
			aStream
				nextPut: $:;
				nextPut: $: ].
	self name ifNotNil: [aStream nextPutAll: self name]! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'simon.denier 9/10/2009 17:58'!
parentScope
	"Polymorphic alias to mimic GlobalVariable#parentScope and similar"

	^ self container! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 11/4/2011 01:40'!
printOn: aStream 
	| parent |
	
	self name ifNotNil: [ aStream nextPutAll: self name ].
	parent := self container.
	parent ifNotNil: [ 
		aStream nextPutAll: ' in '.
		parent mooseNameOn: aStream ].
	aStream 
		nextPutAll: ' (';
		nextPutAll: (self class name removePrefix: 'FAMIX');
		nextPutAll: ')'! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 9/9/2011 17:54'!
realType
	"All types except the alias ones are real"
	^ self ! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:37'!
subclassHierarchy
	| subclasses |
	subclasses := OrderedCollection new.
	self allSubclassesDo: [:each | subclasses add: each].
	^ subclasses! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
subclassHierarchyGroup
	<navigation: 'All subclasses'>
	^ MooseGroup
		withAll: self subclassHierarchy asSet
		withDescription: 'All subclasses of ' , self mooseName! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
superclassHierarchy
	| superclasses |
	superclasses := OrderedCollection new.
	self allSuperclassesDo: [:each | superclasses add: each].
	^ superclasses! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
superclassHierarchyGroup
	<navigation: 'All superclasses'>
	^ MooseGroup
		withAll: self superclassHierarchy asSet
		withDescription: 'All superclasses of ' , self mooseName! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
understands: signature
	"returns true if a class is able to respond to an invocation to aSignature on itself; false otherwise"

	self withSuperclassesDo: [:each | 
		(each implements: signature) ifTrue: [^true]].
	^false! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 9/9/2011 18:51'!
withSubclassHierarchy
	^ self subclassHierarchy 
		addFirst: self realType;
		addAll: self realType allTypeAliases;
		yourself! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
withSubclassHierarchyGroup
	<navigation: 'With all subclasses'>
	^ MooseGroup
		withAll: (self subclassHierarchy asSet; addFirst: self; yourself)
		withDescription: 'With all subclasses of ' , self mooseName! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 9/9/2011 18:50'!
withSuperclassHierarchy
	^ self realType superclassHierarchy 
		addFirst: self realType; 
		addAll: self realType allTypeAliases;
		yourself! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 2/18/2011 09:03'!
withSuperclassHierarchyGroup
	<navigation: 'With all superclasses'>
	^ MooseGroup
		withAll: self withSuperclassHierarchy asSet
		withDescription: 'With all superclasses of ' , self mooseName! !

!FAMIXType methodsFor: '*Famix-Implementation' stamp: 'TudorGirba 12/5/2011 08:34'!
withSuperclassesDo: aBlock
	aBlock value: self.
	self allSuperclassesDo: aBlock! !

Object subclass: #MooseUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Famix-Implementation'!

MooseUtilities subclass: #FAMIXNameResolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Famix-Implementation'!

!FAMIXNameResolver class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
classAttributeSeparator
	^'.'! !

!FAMIXNameResolver class methodsFor: 'naming conventions' stamp: ' 13/6/08 20:49'!
demoosifyGlobal: aString
	^aString copyUpTo: $-! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: ' 13/6/08 20:49'!
isCorrectFullClassName: aClassName
	^(aClassName reverse
		indexOfSubCollection: self FAMIX2NamespaceSeparator
		startingAt: 1) > 0! !

!FAMIXNameResolver class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
methodAndVariableSeparator
	^'.'! !

!FAMIXNameResolver class methodsFor: 'new naming conventions' stamp: 'stephane.ducasse 10/1/2008 11:48'!
mooseNameForAttributeNamed: anAttributeName class: aClassName classSide: aBoolean
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	 aBoolean 
		ifTrue: [^(aClassName, self metaclassTag , self classAttributeSeparator , anAttributeName) asSymbol]
		ifFalse: [^(aClassName , self classAttributeSeparator , anAttributeName) asSymbol]! !

!FAMIXNameResolver class methodsFor: 'new naming conventions' stamp: 'stephane.ducasse 10/1/2008 12:06'!
mooseNameForSharedAttributeNamed: anAttributeName class: aClassName
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	  ^(aClassName, self classAttributeSeparator , anAttributeName) asSymbol
		! !

!FAMIXNameResolver class methodsFor: 'naming conventions' stamp: ' 13/6/08 20:49'!
moosifyGlobal: aString
	^aString , self prefixForGlobalVariable! !

!FAMIXNameResolver class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
prefixForGlobalVariable
	^'-Global'! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: 'stephane.ducasse 8/18/2008 21:36'!
uniqueNameForClassNamed: aClassName scope: uniqueParentNamespaceOrNil
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^uniqueParentNamespaceOrNil isNil
		ifTrue: [aClassName asSymbol]
		ifFalse:
			[(uniqueParentNamespaceOrNil asString , self famixNamespaceSeparator
				, aClassName) asSymbol]! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: 'stephane.ducasse 9/27/2008 15:05'!
uniqueNameForFunctionSignature: aFuncSignature scope: scopeQualifierOrNil
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^(scopeQualifierOrNil isNil or: [scopeQualifierOrNil isEmpty])
		ifTrue: [aFuncSignature asSymbol]
		ifFalse:
			[(scopeQualifierOrNil name asString , self famixNamespaceSeparator
				, aFuncSignature) asSymbol]! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: 'stephane.ducasse 9/27/2008 15:05'!
uniqueNameForGlobalVariableNamed: aVarName scope: scopeQualifierOrNil
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	"Note that the problem in VW is that global variable and namespace can have the same name"

	^scopeQualifierOrNil isNil
		ifTrue: [(self moosifyGlobal: aVarName) asSymbol]
		ifFalse:
			[(scopeQualifierOrNil asString , self famixNamespaceSeparator , self
				moosifyGlobal: aVarName) asSymbol]! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: ' 13/6/08 20:49'!
uniqueNameForImplicitVariableNamed: aVarName scope: scopeQualifierOrNil
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^(scopeQualifierOrNil isNil or: [scopeQualifierOrNil isEmpty])
		ifTrue: [aVarName asSymbol]
		ifFalse:
			[(scopeQualifierOrNil , self methodAndVariableSeparator , aVarName)
				asSymbol]! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: ' 13/6/08 20:49'!
uniqueNameForLocalVariableNamed: aVariableName belongsTo: aBehaviourName
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^(aBehaviourName , self methodAndVariableSeparator , aVariableName)
		asSymbol! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: ' 13/6/08 20:49'!
uniqueNameForMethodSignature: aMethodSignature hasClassScope: aBooleanOrNil class: aClassName
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^(aClassName , self methodAndVariableSeparator , aMethodSignature)
		asSymbol! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: ' 13/6/08 20:49'!
uniqueNameForMethodWithSmalltalkSelector: aSymbol hasClassScope: aBooleanOrNil class: aClassName
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^self
		uniqueNameForMethodSignature:
			(self signatureFromSmalltalkSelector: aSymbol)
		hasClassScope: aBooleanOrNil
		class: aClassName! !

!FAMIXNameResolver class methodsFor: 'language independent unique naming' stamp: 'stephane.ducasse 9/27/2008 15:05'!
uniqueNameForNamespaceNamed: aNamespaceName scope: uniqueParentNamespaceName
	"Given ***FAMIX2 compliant**** names for the elements return a FAMIX2 Compliant uniqueName a SYMBOL"

	^(uniqueParentNamespaceName isNil or: [uniqueParentNamespaceName isEmpty])
		ifTrue: [aNamespaceName asSymbol]
		ifFalse:
			[(uniqueParentNamespaceName asString , self famixNamespaceSeparator
				, aNamespaceName) asSymbol]! !

!MooseUtilities class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
browserCategoryTag
	^'browsercategory '! !

!MooseUtilities class methodsFor: 'naming' stamp: ' 13/6/08 20:49'!
browserCategoryToSourceAnchor: aCategory
	"returns a string representing the source anchor for smalltalk method entities"

	^self browserCategoryTag , aCategory asString! !

!MooseUtilities class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
classNamed: aClassNameSymbol orNilInNamespace: aNamespace
	"return the class defined in the namespace or its contained namespace or nil"

	| res |
	res := aNamespace allClasses
		detect:
			[:each | 
			each name asSymbol == aClassNameSymbol
				or: [each fullName asSymbol == aClassNameSymbol]]
		ifNone: [nil].
	^res! !

!MooseUtilities class methodsFor: 'encoding extraction' stamp: 'simon.denier 5/20/2009 00:36'!
extractCategoryNameFromMoose: aString
	"returns the first part of a compound string. In Moose the variable name are composed this way"

	"(self extractCategoryNameFromMoose: (self browserCategoryToSourceAnchor: 'accessing')) = 'accessing'"

	| tag |
	tag := self browserCategoryTag.
	aString
		findString: tag
		startingAt: 1.
	^aString
		copyFrom: tag size + 1
		to: aString size! !

!MooseUtilities class methodsFor: 'encoding extraction' stamp: ' 13/6/08 20:49'!
extractMethodSelectorFromMoose: aString
	"returns the first part of a compound string. In Moose the variable name are composed this way"

	"self extractMethodSelectorFromMoose: #'accept:node:()' 'accept:node:'"

	"self extractMethodSelectorFromMoose: #'accept()' 'accept'"

	^aString copyUpTo: $(! !

!MooseUtilities class methodsFor: 'encoding extraction' stamp: ' 13/6/08 20:49'!
extractMooseClassSymbolFrom: aString
	"returns the class name of a Moose  variable name"

	"self extractMooseClassSymbolFrom: #'LanInterface.super'"

	"self extractMooseClassSymbolFrom: #'LanInterface.self'"

	"self extractMooseClassSymbolFrom: #'LanInterface.self.dddd'"

	^aString classPart! !

!MooseUtilities class methodsFor: 'encoding extraction' stamp: ' 13/6/08 20:49'!
extractPathFromAnchor: anchor
	| start end path |
	start := anchor indexOf: $".
	end := anchor lastIndexOf: $".
	path := anchor
		copyFrom: start + 1
		to: end - 1.
	^path! !

!MooseUtilities class methodsFor: 'encoding extraction' stamp: ' 13/6/08 20:49'!
extractStartFromAnchor: anchor
	| begin end start |
	begin := (anchor
		indexOfSubCollection: 'start'
		startingAt: 1) + 6.
	end := (anchor
		indexOfSubCollection: 'end'
		startingAt: 1) - 2.
	start := anchor
		copyFrom: begin
		to: end.
	^start asNumber! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 18:55'!
famixFullClassNameForSmalltalkFullName: aBinding
	"only sent by UnitTests, not by domain"

	^(self findClassNamedOrNilFromFullName: aBinding) mooseName! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 18:55'!
famixFullMetaclassNameForSmalltalkFullName: aBinding
	^(self findClassNamedOrNilFromFullName: aBinding) class mooseName! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 18:55'!
famixFullNamespaceNameForSmalltalkNamespace: aNamespace
	"self FAMIX2FullNamespaceNameForSmalltalkNamespace:#{SCG.Moose} value"

	"self halt: 'Soops: inlined all senders for speed'"

	^aNamespace mooseName! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 18:56'!
famixNameFromFamixFullName: aFullName
	" (aFullName copyFrom: 1 to: (aFullName lastIndexOf: $:) - 2) asSymbol"

	^(aFullName
		copyFrom:
			aFullName size
				-
					(aFullName reverse
						indexOfSubCollection: self famixNamespaceSeparator
						startingAt: 1) + 2
		to: aFullName size) asSymbol! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 18:56'!
famixNamespaceNameFromFamixFullName: aFullName
	" (aFullName copyFrom: 1 to: (aFullName lastIndexOf: $:) - 2) asSymbol"

	^(aFullName
		copyFrom: 1
		to:
			aFullName size
				-
					(aFullName reverse
						indexOfSubCollection: self famixNamespaceSeparator
						startingAt: 1) - 1) asSymbol! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 18:54'!
famixNamespaceSeparator
	^'::'! !

!MooseUtilities class methodsFor: 'getting classes' stamp: 'simon.denier 5/23/2009 20:58'!
findClassNamedOrNilFromFullName: stClassFullNameSymbol
	"returns the class whose name is aClassFullNameSymbol. 
	aClassFullNameSymbol should smalltalk and not moose related.and should not represent a metaclass"
	
	^ self class environment at: stClassFullNameSymbol asSymbol ifAbsent: [nil]

	"Alternative could be 
						cls := Compiler evaluate: 'SomeClassName'.
						cls isBehavior
						ifTrue: [^cls]"

	"Or older alternative dealing with namespaces:
		| aClassNameSymbol |	
		aClassNameSymbol := aClassFullNameSymbol asSymbol.
		^Root allClasses detect: [:each | each fullName asSymbol == aClassNameSymbol]
			ifNone: [nil]	"

"	^(stClassFullNameSymbol includes: $.)
		ifTrue:
			[(LiteralBindingReference pathString: stClassFullNameSymbol asString)
				ifDefinedDo: [:cl | cl]
				elseDo: [nil]]
		ifFalse:
			[self
				findClassNamedOrNilFromFullName:
					('Smalltalk.' , stClassFullNameSymbol) asSymbol]"! !

!MooseUtilities class methodsFor: 'testing' stamp: 'stephane.ducasse 8/21/2008 10:57'!
isStoreLoaded
	^false! !

!MooseUtilities class methodsFor: 'getting classes' stamp: 'simon.denier 5/23/2009 20:13'!
isVariableAClass: aSymbol
	"self isVariableAClass: self name"

	"returns true if aSymbol represents a Class"
	aSymbol size = 0 ifTrue: [^false].
	aSymbol first isLowercase ifTrue: [^false].
	^ (Smalltalk at: aSymbol) isBehavior
	
	"aString asQualifiedReference bindingOrNil
		ifNil:
			[Root allClasses anySatisfy: [:each | each name asString = aString]]
		ifNotNil: [aString asQualifiedReference bindingOrNil isForClass]"! !

!MooseUtilities class methodsFor: 'getting classes' stamp: 'simon.denier 5/23/2009 21:22'!
isVariableAGlobal: aString
	"returns true if aString represents a GlobalVariable"

	| globalObject |
	globalObject := Smalltalk at: aString printString withoutQuoting asSymbol ifAbsent: [^false].
	^ globalObject isBehavior not and: [globalObject isTrait not].

	"qualified := aString asQualifiedReference.
	qualified isDefined ifFalse: [^false].
	bin := qualified bindingOrNil.
	^bin isNil
		ifTrue: [false]
		ifFalse: [bin isForGeneral]"! !

!MooseUtilities class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
metaclassTag
	"The meta class tag used in FAMIX2."

	^'_class'! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 19:04'!
moosify: aString

	^aString
		copyReplaceAll: self smalltalkNamespaceSeparator
		with: self famixNamespaceSeparator! !

!MooseUtilities class methodsFor: 'naming' stamp: ' 13/6/08 20:49'!
signatureFromSmalltalkSelector: aName
	"self signatureFromSmalltalkSelector: #new"

	"self signatureFromSmalltalkSelector: #new:"

	"self signatureFromSmalltalkSelector: #with:with:"

	"self signatureFromSmalltalkSelector: #with:with:with:"

	"self signatureFromSmalltalkSelector: #'+'"

	| sym ws numArgs |
	sym := aName asSymbol.
	numArgs := sym numArgs.
	ws := WriteStream on: (String new: sym size + (numArgs * 7) + 3).
	ws
		nextPutAll: sym;
		nextPut: $(.
	1
		to: numArgs
		do: [:inx | ws nextPutAll: 'Object,'].
	numArgs > 0 ifTrue: [ws skip: -1	"remove last space"].
	ws nextPut: $).
	^ws contents asSymbol! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'tg 8/4/2009 20:20'!
smalltalkClassFromFamixClassName: aFAMIXName
	^ self smalltalkClassFromFamixClassName: aFAMIXName ifAbsent: [
		self error: 'No Smalltalk class corresponds to the, ', aFAMIXName, ' FAMIX name']! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'tg 8/4/2009 20:27'!
smalltalkClassFromFamixClassName: aFAMIXName ifAbsent: aBlock
	"Given the FAMIX2 name for a class (for a meta class or not): return 
	that Smalltalk class."

	| stName isMeta newName res |
	stName := self smalltalkClassNameFromFamixClassName: aFAMIXName.
	isMeta := '*' , self stMetaclassTag match: stName.
	newName := isMeta 
		ifTrue: [stName copyFrom: 1 to: stName size - self stMetaclassTag size]
		ifFalse: [stName].
	res := self findClassNamedOrNilFromFullName: newName.
	^res isNil
		ifTrue: [aBlock value]
		ifFalse: [isMeta ifTrue: [res class] ifFalse: [res]]! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'tg 8/4/2009 20:57'!
smalltalkClassNameFromFamixClassName: aFAMIXName
	"Given the FAMIX2 name for a class (for a meta class or not): return the Smalltalk name."

	| isMetaclass index |
	isMetaclass := '*' , self metaclassTag match: aFAMIXName.
	
	"we check whether there is a reference to a namespace in the famix name"
	index := aFAMIXName findString: self famixNamespaceSeparator.
	index := index isZero 
				ifTrue: [1]
				ifFalse: [(aFAMIXName findString: self famixNamespaceSeparator) + self famixNamespaceSeparator size].
	^ isMetaclass
		ifTrue: [ ((aFAMIXName copyFrom: index to: ((aFAMIXName findString: self metaclassTag) -1) ), ' class') asSymbol]
		ifFalse: [ (aFAMIXName copyFrom: index to: aFAMIXName size) asSymbol ]
! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: ' 13/6/08 20:49'!
smalltalkNamespaceSeparator
	^'.'! !

!MooseUtilities class methodsFor: 'naming conventions' stamp: 'stephane.ducasse 6/29/2008 19:00'!
soleClassNameFromFamixName: aFAMIX2Name
	"return the class (sole instance) of the FAMIX2 name"

	| FAMIX2Name isMetaclass |
	FAMIX2Name := self smalltalkClassNameFromFamixClassName: aFAMIX2Name.
	isMetaclass := '*' , self stMetaclassTag match: FAMIX2Name.
	^isMetaclass
		ifTrue:
			[(FAMIX2Name
				copyFrom: 1
				to: FAMIX2Name size - self metaclassTag size) asSymbol]
		ifFalse: [FAMIX2Name]! !

!MooseUtilities class methodsFor: 'private' stamp: ' 13/6/08 20:49'!
stMetaclassTag
	"The meta class tag used in SmalltLK."

	^' class'! !

!MooseUtilities class methodsFor: 'naming' stamp: ' 13/6/08 20:49'!
stopWordList
	"Answer a list of english stop words, a defind by SMART.  See ftp://ftp.cs.cornell.edu/pub/smart/"

	^'a a''s able about above according accordingly across actually after afterwards again against ain''t all allow allows almost alone along already also although always am among amongst an and another any anybody anyhow anyone anything anyway anyways anywhere apart appear appreciate appropriate are aren''t around as aside ask asking associated at available away awfully b be became because become becomes becoming been before beforehand behind being believe below beside besides best better between beyond both brief but by c c''mon c''s came can can''t cannot cant cause causes certain certainly changes clearly co com come comes concerning consequently consider considering contain containing contains corresponding could couldn''t course currently d definitely described despite did didn''t different do does doesn''t doing don''t done down downwards during e each edu eg eight either else elsewhere enough entirely especially et etc even ever every everybody everyone everything everywhere ex exactly example except f far few fifth first five followed following follows for former formerly forth four from further furthermore g get gets getting given gives go goes going gone got gotten greetings h had hadn''t happens hardly has hasn''t have haven''t having he he''s hello help hence her here here''s hereafter hereby herein hereupon hers herself hi him himself his hither hopefully how howbeit however i i''d i''ll i''m i''ve ie if ignored immediate in inasmuch inc indeed indicate indicated indicates inner insofar instead into inward is isn''t it it''d it''ll it''s its itself j just k keep keeps kept know knows known l last lately later latter latterly least less lest let let''s like liked likely little look looking looks ltd m mainly many may maybe me mean meanwhile merely might more moreover most mostly much must my myself n name namely nd near nearly necessary need needs neither never nevertheless new next nine no nobody non none noone nor normally not nothing novel now nowhere o obviously of off often oh ok okay old on once one ones only onto or other others otherwise ought our ours ourselves out outside over overall own p particular particularly per perhaps placed please plus possible presumably probably provides q que quite qv r rather rd re really reasonably regarding regardless regards relatively respectively right s said same saw say saying says second secondly see seeing seem seemed seeming seems seen self selves sensible sent serious seriously seven several shall she should shouldn''t since six so some somebody somehow someone something sometime sometimes somewhat somewhere soon sorry specified specify specifying still sub such sup sure t t''s take taken tell tends th than thank thanks thanx that that''s thats the their theirs them themselves then thence there there''s thereafter thereby therefore therein theres thereupon these they they''d they''ll they''re they''ve think third this thorough thoroughly those though three through throughout thru thus to together too took toward towards tried tries truly try trying twice two u un under unfortunately unless unlikely until unto up upon us use used useful uses using usually uucp v value various very via viz vs w want wants was wasn''t way we we''d we''ll we''re we''ve welcome well went were weren''t what what''s whatever when whence whenever where where''s whereafter whereas whereby wherein whereupon wherever whether which while whither who who''s whoever whole whom whose why will willing wish with within without won''t wonder would would wouldn''t x y yes yet you you''d you''ll you''re you''ve your yours yourself yourselves z zero'
		runsFailing: #isSeparator! !
